blob: 9c0806948606e6cbaa75f48c42d96ce63fc85784 [file] [log] [blame]
Linux Foundation Administrators1dc9dd52018-01-26 09:09:09 -08001#!/bin/bash
2
3# vim: ts=4 sw=4 sts=4 et tw=72 :
4
5# force any errors to cause the script and job to end in failure
6set -xeu -o pipefail
7
8ensure_kernel_install() {
9 # Workaround for mkinitrd failing on occassion.
10 # On CentOS 7 it seems like the kernel install can fail it's mkinitrd
11 # run quietly, so we may not notice the failure. This script retries for a
12 # few times before giving up.
13 initramfs_ver=$(rpm -q kernel | tail -1 | sed "s/kernel-/initramfs-/")
14 grub_conf="/boot/grub/grub.conf"
15 # Public cloud does not use /boot/grub/grub.conf and uses grub2 instead.
16 if [ ! -e "$grub_conf" ]; then
17 echo "$grub_conf not found. Using Grub 2 conf instead."
18 grub_conf="/boot/grub2/grub.cfg"
19 fi
20
21 for i in $(seq 3); do
22 if grep "$initramfs_ver" "$grub_conf"; then
23 break
24 fi
25 echo "Kernel initrd missing. Retrying to install kernel..."
26 yum reinstall -y kernel
27 done
28 if ! grep "$initramfs_ver" "$grub_conf"; then
29 cat /boot/grub/grub.conf
30 echo "ERROR: Failed to install kernel."
31 exit 1
32 fi
33}
34
35ensure_ubuntu_install() {
36 # Workaround for mirrors occassionally failing to install a package.
37 # On Ubuntu sometimes the mirrors fail to install a package. This wrapper
38 # checks that a package is successfully installed before moving on.
39
40 packages=($@)
41
42 for pkg in "${packages[@]}"
43 do
44 # Retry installing package 5 times if necessary
45 for i in {0..5}
46 do
47 if [ "$(dpkg-query -W -f='${Status}' "$pkg" 2>/dev/null | grep -c "ok installed")" -eq 0 ]; then
48 apt-cache policy "$pkg"
49 apt-get install "$pkg"
50 continue
51 else
52 echo "$pkg already installed."
53 break
54 fi
55 done
56 done
57}
58
59rh_systems() {
60 # Handle the occurance where SELINUX is actually disabled
61 SELINUX=$(grep -E '^SELINUX=(disabled|permissive|enforcing)$' /etc/selinux/config)
62 MODE=$(echo "$SELINUX" | cut -f 2 -d '=')
63 case "$MODE" in
64 permissive)
65 echo "************************************"
66 echo "** SYSTEM ENTERING ENFORCING MODE **"
67 echo "************************************"
68 # make sure that the filesystem is properly labelled.
69 # it could be not fully labeled correctly if it was just switched
70 # from disabled, the autorelabel misses some things
71 # skip relabelling on /dev as it will generally throw errors
72 restorecon -R -e /dev /
73
74 # enable enforcing mode from the very start
75 setenforce enforcing
76
77 # configure system for enforcing mode on next boot
78 sed -i 's/SELINUX=permissive/SELINUX=enforcing/' /etc/selinux/config
79 ;;
80 disabled)
81 sed -i 's/SELINUX=disabled/SELINUX=permissive/' /etc/selinux/config
82 touch /.autorelabel
83
84 echo "*******************************************"
85 echo "** SYSTEM REQUIRES A RESTART FOR SELINUX **"
86 echo "*******************************************"
87 ;;
88 enforcing)
89 echo "*********************************"
90 echo "** SYSTEM IS IN ENFORCING MODE **"
91 echo "*********************************"
92 ;;
93 esac
94
95 # Allow jenkins access to alternatives command to switch java version
96 cat <<EOF >/etc/sudoers.d/89-jenkins-user-defaults
97Defaults:jenkins !requiretty
98jenkins ALL = NOPASSWD: /usr/sbin/alternatives
99EOF
100
101 echo "---> Updating operating system"
102 yum clean all
103 yum install -y deltarpm
104 yum update -y
105
106 ensure_kernel_install
107
108 # add in components we need or want on systems
109 echo "---> Installing base packages"
110 yum install -y @base https://dl.fedoraproject.org/pub/epel/epel-release-latest-7.noarch.rpm
111 # separate group installs from package installs since a non-existing
112 # group with dnf based systems (F21+) will fail the install if such
113 # a group does not exist
114 yum install -y unzip xz puppet git git-review perl-XML-XPath
115 yum install -y python-{devel,virtualenv,setuptools,pip}
116
117 # All of our systems require Java (because of Jenkins)
118 # Install all versions of the OpenJDK devel but force 1.7.0 to be the
119 # default
120
121 echo "---> Configuring OpenJDK"
122 yum install -y 'java-*-openjdk-devel'
123
124 FACTER_OS=$(/usr/bin/facter operatingsystem)
125 FACTER_OSVER=$(/usr/bin/facter operatingsystemrelease)
126 case "$FACTER_OS" in
127 Fedora)
128 if [ "$FACTER_OSVER" -ge "21" ]
129 then
130 echo "---> not modifying java alternatives as OpenJDK 1.7.0 does not exist"
131 else
132 alternatives --set java /usr/lib/jvm/jre-1.7.0-openjdk.x86_64/bin/java
133 alternatives --set java_sdk_openjdk /usr/lib/jvm/java-1.7.0-openjdk.x86_64
134 fi
135 ;;
136 RedHat|CentOS)
137 if [ "$(echo "$FACTER_OSVER" | cut -d'.' -f1)" -ge "7" ]
138 then
139 echo "---> not modifying java alternatives as OpenJDK 1.7.0 does not exist"
140 else
141 alternatives --set java /usr/lib/jvm/jre-1.7.0-openjdk.x86_64/bin/java
142 alternatives --set java_sdk_openjdk /usr/lib/jvm/java-1.7.0-openjdk.x86_64
143 fi
144 ;;
145 *)
146 alternatives --set java /usr/lib/jvm/jre-1.7.0-openjdk.x86_64/bin/java
147 alternatives --set java_sdk_openjdk /usr/lib/jvm/java-1.7.0-openjdk.x86_64
148 ;;
149 esac
150
151 ########################
152 # --- START LFTOOLS DEPS
153
154 # Used by various scripts to push patches to Gerrit
155 yum install -y git-review
156
157 # Needed to parse OpenStack commands used by opendaylight-infra stack commands
158 # to initialize Heat template based systems.
159 yum install -y jq
160
161 # Used by lftools scripts to parse XML
162 yum install -y xmlstarlet
163
164 # Haskel Packages
165 # Cabal update fails on a 1G system so workaround that with a swap file
166 dd if=/dev/zero of=/tmp/swap bs=1M count=1024
167 mkswap /tmp/swap
168 swapon /tmp/swap
169
170 yum install -y cabal-install
171 cabal update
172 cabal install "Cabal<1.18" # Pull Cabal version that is capable of building shellcheck
173 cabal install --bindir=/usr/local/bin "shellcheck-0.4.6" # Pin shellcheck version
174
175 # --- END LFTOOLS DEPS
176 ######################
177
178 # install haveged to avoid low entropy rejecting ssh connections
179 yum install -y haveged
180 systemctl enable haveged.service
181}
182
183ubuntu_systems() {
184 # Ignore SELinux since slamming that onto Ubuntu leads to
185 # frustration
186
187 # Allow jenkins access to update-alternatives command to switch java version
188 cat <<EOF >/etc/sudoers.d/89-jenkins-user-defaults
189Defaults:jenkins !requiretty
190jenkins ALL = NOPASSWD: /usr/bin/update-alternatives
191EOF
192
193 export DEBIAN_FRONTEND=noninteractive
194 cat <<EOF >> /etc/apt/apt.conf
195APT {
196 Get {
197 Assume-Yes "true";
198 allow-change-held-packages "true";
199 allow-downgrades "true";
200 allow-remove-essential "true";
201 };
202};
203
204Dpkg::Options {
205 "--force-confdef";
206 "--force-confold";
207};
208
209EOF
210
211 # Add hostname to /etc/hosts to fix 'unable to resolve host' issue with sudo
212 sed -i "/127.0.0.1/s/$/ $(hostname)/" /etc/hosts
213
214 echo "---> Updating operating system"
215
Zack Williams852578f2018-04-12 14:03:57 -0700216 # Change made 2018-07-09 by zdw
217 # per discussion on #lf-releng, the upstream Ubuntu image changed to be
218 # missing add-apt-repository, so the next command failed.
219 apt-get update -m
220 apt-get install -y software-properties-common
221
Linux Foundation Administrators1dc9dd52018-01-26 09:09:09 -0800222 # add additional repositories
Zack Williams852578f2018-04-12 14:03:57 -0700223 add-apt-repository "deb http://us.archive.ubuntu.com/ubuntu $(lsb_release -sc) main universe restricted multiverse"
Linux Foundation Administrators1dc9dd52018-01-26 09:09:09 -0800224
225 echo "---> Installing base packages"
226 apt-get clean
227 apt-get update -m
228 apt-get upgrade -m
229 apt-get dist-upgrade -m
230
Andy Bavierb781c4c2018-09-20 08:16:52 -0700231 apt-get update -m
Linux Foundation Administrators1dc9dd52018-01-26 09:09:09 -0800232 ensure_ubuntu_install unzip xz-utils puppet git libxml-xpath-perl
233
234 # install Java 7
235 echo "---> Configuring OpenJDK"
236 FACTER_OSVER=$(/usr/bin/facter operatingsystemrelease)
237 case "$FACTER_OSVER" in
238 14.04)
239 apt-get install openjdk-7-jdk
240 # make jdk8 available
241 add-apt-repository -y ppa:openjdk-r/ppa
242 apt-get update
243 # We need to force openjdk-8-jdk to install
244 apt-get install openjdk-8-jdk
245 # make sure that we still default to openjdk 7
246 update-alternatives --set java /usr/lib/jvm/java-7-openjdk-amd64/jre/bin/java
247 update-alternatives --set javac /usr/lib/jvm/java-7-openjdk-amd64/bin/javac
248 ;;
249 16.04)
250 apt-get install openjdk-8-jdk
251 ;;
252 *)
253 echo "---> Unknown Ubuntu version $FACTER_OSVER"
254 exit 1
255 ;;
256 esac
257
258 ########################
259 # --- START LFTOOLS DEPS
260
261 # Used by various scripts to push patches to Gerrit
262 ensure_ubuntu_install git-review
263
264 # Needed to parse OpenStack commands used by opendaylight-infra stack commands
265 # to initialize Heat template based systems.
266 ensure_ubuntu_install jq
267
268 # Used by lftools scripts to parse XML
269 ensure_ubuntu_install xmlstarlet
270
Zack Williamsae52f5e2018-04-12 11:47:57 -0700271 # Change made by zdw on 2018-04-12
272 # hackage.haskell.org was down, talked to zxiiro on #lf-releng and he recommended
273 # pulling down the packages in a way similar to this ansible role, rather than using cabal:
274 # https://github.com/lfit/ansible-roles-shellcheck-install/blob/master/tasks/main.yml
Linux Foundation Administrators1dc9dd52018-01-26 09:09:09 -0800275
Zack Williamsae52f5e2018-04-12 11:47:57 -0700276 SHELLCHECK_VERSION="v0.4.7"
277 SHELLCHECK_SHA256SUM="deeea92a4d3a9c5b16ba15210d9c1ab84a2e12e29bf856427700afd896bbdc93"
278 curl -L -o /tmp/shellcheck.tar.xz https://storage.googleapis.com/shellcheck/shellcheck-${SHELLCHECK_VERSION}.linux.x86_64.tar.xz
279 echo "$SHELLCHECK_SHA256SUM /tmp/shellcheck.tar.xz" | sha256sum -c -
280 pushd /tmp
281 tar -xJvf shellcheck.tar.xz
282 cp shellcheck-${SHELLCHECK_VERSION}/shellcheck /usr/local/bin/shellcheck
283 chmod a+x /usr/local/bin/shellcheck
284 popd
Linux Foundation Administrators1dc9dd52018-01-26 09:09:09 -0800285
286 # --- END LFTOOLS DEPS
287 ######################
288
289 # install haveged to avoid low entropy rejecting ssh connections
290 apt-get install haveged
291 update-rc.d haveged defaults
292
293 # disable unattended upgrades & daily updates
294 echo '---> Disabling automatic daily upgrades'
295 sed -ine 's/"1"/"0"/g' /etc/apt/apt.conf.d/10periodic
296 echo 'APT::Periodic::Unattended-Upgrade "0";' >> /etc/apt/apt.conf.d/10periodic
297}
298
299all_systems() {
300 # Do any Distro specific installations here
301 echo "Checking distribution"
302 FACTER_OS=$(/usr/bin/facter operatingsystem)
303 case "$FACTER_OS" in
304 *)
305 echo "---> $FACTER_OS found"
306 echo "No extra steps for $FACTER_OS"
307 ;;
308 esac
309}
310
311echo "---> Attempting to detect OS"
312# upstream cloud images use the distro name as the initial user
313ORIGIN=$(if [ -e /etc/redhat-release ]
314 then
315 echo redhat
316 else
317 echo ubuntu
318 fi)
319#ORIGIN=$(logname)
320
321case "${ORIGIN}" in
322 fedora|centos|redhat)
323 echo "---> RH type system detected"
324 rh_systems
325 ;;
326 ubuntu)
327 echo "---> Ubuntu system detected"
328 ubuntu_systems
329 ;;
330 *)
331 # Kill the build for unhandled distributions
332 echo "---> Unknown operating system" 1>&2
333 exit 1
334 ;;
335esac
336
337# execute steps for all systems
338all_systems